## cvc5 1.0.5

=== CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Aina Niemetz, Mathias Preiner, Gereon Kremer
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

cmake_minimum_required(VERSION 3.12)

#-----------------------------------------------------------------------------#
# Project configuration

project(cvc5)

include(CheckIPOSupported)
include(GNUInstallDirs)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

include(version)

set(CMAKE_C_STANDARD 99)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# Generate compile_commands.json, which can be used for various code completion
# plugins.
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

#-----------------------------------------------------------------------------#
# Policies

# Required for FindGLPK since it sets CMAKE_REQUIRED_LIBRARIES
if(POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

if(POLICY CMP0135)
  # For `ExternalProject_Add()`, set the timestamp of the files extracted from
  # the downloaded archive to the time of the extraction. This behavior was
  # introduced in CMake 3.23 and is the recommended to make sure that
  # dependencies get rebuilt when the URL changes.
  cmake_policy(SET CMP0135 NEW)
endif()

#-----------------------------------------------------------------------------#
# Tell CMake where to find our dependencies

if(GLPK_DIR)
  list(APPEND CMAKE_PREFIX_PATH "${GLPK_DIR}")
endif()

# By default the contrib/get-* scripts install dependencies to deps/install.
list(APPEND CMAKE_PREFIX_PATH "${PROJECT_SOURCE_DIR}/deps/install")

#-----------------------------------------------------------------------------#

include(Helpers)

#-----------------------------------------------------------------------------#
# User options

# License
option(ENABLE_GPL "Enable GPL dependencies")

# General build options
#
# >> 3-valued: IGNORE ON OFF
#    > allows to detect if set by user (default: IGNORE)
#    > only necessary for options set for build types
option(BUILD_SHARED_LIBS          "Build shared libraries and binary")
cvc5_option(ENABLE_ASAN           "Enable ASAN build")
cvc5_option(ENABLE_UBSAN          "Enable UBSan build")
cvc5_option(ENABLE_TSAN           "Enable TSan build")
cvc5_option(ENABLE_ASSERTIONS     "Enable assertions")
cvc5_option(ENABLE_COMP_INC_TRACK
            "Enable optimizations for incremental SMT-COMP tracks")
cvc5_option(ENABLE_DEBUG_SYMBOLS  "Enable debug symbols")
cvc5_option(ENABLE_MUZZLE         "Suppress ALL non-result output")
cvc5_option(ENABLE_STATISTICS     "Enable statistics")
cvc5_option(ENABLE_TRACING        "Enable tracing")
cvc5_option(ENABLE_UNIT_TESTING   "Enable unit testing")
cvc5_option(ENABLE_VALGRIND       "Enable valgrind instrumentation")
cvc5_option(ENABLE_AUTO_DOWNLOAD  "Enable automatic download of dependencies")
cvc5_option(ENABLE_IPO            "Enable interprocedural optimization")
# >> 2-valued: ON OFF
#    > for options where we don't need to detect if set by user (default: OFF)
option(ENABLE_COVERAGE         "Enable support for gcov coverage testing")
option(ENABLE_DEBUG_CONTEXT_MM "Enable the debug context memory manager")
option(ENABLE_PROFILING        "Enable support for gprof profiling")

# Optional dependencies
#
# >> 2-valued: ON OFF
#    > for options where we don't need to detect if set by user (default: OFF)
option(USE_CLN           "Use CLN instead of GMP")
option(USE_COCOA         "Use CoCoALib for further polynomial operations")
option(USE_CRYPTOMINISAT "Use CryptoMiniSat SAT solver")
option(USE_EDITLINE      "Use Editline for better interactive support")
option(USE_GLPK          "Use GLPK simplex solver")
option(USE_KISSAT        "Use Kissat SAT solver")
option(USE_POLY          "Use LibPoly for polynomial arithmetic")

# Custom install directories for dependencies
# If no directory is provided by the user, we first check if the dependency was
# installed via the corresponding contrib/get-* script and if not found, we
# check the intalled system version. If the user provides a directory we
# immediately fail if the dependency was not found at the specified location.
set(GLPK_DIR          "" CACHE STRING "Set GLPK install directory")

# Prepend binaries with prefix on make install
set(PROGRAM_PREFIX    "" CACHE STRING "Program prefix on make install")

# Supported language bindings based on new C++ API
option(BUILD_BINDINGS_PYTHON "Build Python bindings based on new C++ API ")
option(BUILD_BINDINGS_JAVA "Build Java bindings based on new C++ API ")

# Api documentation
option(BUILD_DOCS "Build Api documentation")

# Link against static system libraries
cvc5_option(STATIC_BINARY "Link against static system libraries \
(enabled by default for static builds)")

# Custom flags for WebAssembly compilation
set(WASM_FLAGS "" CACHE STRING "Link flags for the WebAssembly binary generation")
set(WASM "OFF" CACHE STRING "Use a specific extension for WebAssembly compilation")

# Make sure no other available value will be assigned to this variable
if(NOT(WASM STREQUAL "WASM" OR WASM STREQUAL "JS" OR WASM STREQUAL "HTML" OR WASM STREQUAL "OFF"))
  message(FATAL_ERROR "${WASM} is not a valid wasm flag value.")
endif()

if(WASM STREQUAL "OFF")
  set(WASM_FLAGS "")
  set(CONFIGURE_CMD_WRAPPER "")
# If it's a wasm compilation, but isn't using the right flags
elseif(BUILD_SHARED_LIBS OR NOT(STATIC_BINARY) OR NOT(ENABLE_AUTO_DOWNLOAD))
  message(FATAL_ERROR "Use --static, --static-binary and --auto-download flags for WebAssembly compilation. GMP will not compile with shared libraries.")
else()
  set(CONFIGURE_CMD_WRAPPER emconfigure)
  set(TOOLCHAIN_PREFIX wasm64-unknown-emscripten)
  string(TOLOWER ".${WASM}" WASM_EXTENSION)
  set(CMAKE_EXECUTABLE_SUFFIX ${WASM_EXTENSION})
  string(APPEND CMAKE_EXE_LINKER_FLAGS " ${WASM_FLAGS}")
endif()

#-----------------------------------------------------------------------------#
# Internal cmake variables

set(OPTIMIZATION_LEVEL 3)
set(GPL_LIBS "")

#-----------------------------------------------------------------------------#
# Determine number of threads available, used to configure (default) parallel
# execution of custom test targets (can be overriden with ARGS=-jN).

include(ProcessorCount)
ProcessorCount(CTEST_NTHREADS)
if(CTEST_NTHREADS EQUAL 0)
  set(CTEST_NTHREADS 1)
endif()

#-----------------------------------------------------------------------------#
# Build types

# Note: Module CodeCoverage requires the name of the debug build to conform
#       to cmake standards (first letter uppercase).
set(BUILD_TYPES Production Debug Testing Competition)

if(ENABLE_ASAN OR ENABLE_UBSAN OR ENABLE_TSAN)
  set(CMAKE_BUILD_TYPE Debug)
endif()

# Set the default build type to Production
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE
      Production CACHE STRING "Options are: ${BUILD_TYPES}" FORCE)
  # Provide drop down menu options in cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${BUILD_TYPES})
endif()

# Check if specified build type is valid.
list(FIND BUILD_TYPES ${CMAKE_BUILD_TYPE} FOUND_BUILD_TYPE)
if(${FOUND_BUILD_TYPE} EQUAL -1)
  message(FATAL_ERROR
    "'${CMAKE_BUILD_TYPE}' is not a valid build type. "
    "Available builds are: ${BUILD_TYPES}")
endif()

message(STATUS "Building ${CMAKE_BUILD_TYPE} build")
include(Config${CMAKE_BUILD_TYPE})

#-----------------------------------------------------------------------------#
# Compiler flags

add_check_c_cxx_flag("-O${OPTIMIZATION_LEVEL}")
add_check_c_cxx_flag("-Wall")
add_check_c_cxx_supression_flag("-Wno-unused-private-field")
add_check_c_flag("-fexceptions")
add_check_cxx_flag("-Wsuggest-override")
add_check_cxx_flag("-Wnon-virtual-dtor")
add_check_c_cxx_flag("-Wimplicit-fallthrough")
add_check_c_cxx_flag("-Wshadow")

# Assume no dynamic initialization of thread-local variables in non-defining
# translation units. This option should result in better performance and works
# around crashing issues with our Windows build.
add_check_cxx_flag("-fno-extern-tls-init")

# Disable -Wclass-memaccess to suppress 'no trivial copy-assignment' in MiniSat
# code.
add_check_cxx_supression_flag("-Wno-class-memaccess")

if (WIN32)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--stack,100000000")

  # ANTLR uses pragmas that certain versions of MinGW does not support
  add_check_c_cxx_flag("-Wno-error=unknown-pragmas")
endif ()

#-----------------------------------------------------------------------------#
# Use ld.gold if available

execute_process(COMMAND ${CMAKE_C_COMPILER}
                -fuse-ld=gold
                -Wl,--version ERROR_QUIET OUTPUT_VARIABLE LD_VERSION)
if ("${LD_VERSION}" MATCHES "GNU gold")
  string(APPEND CMAKE_EXE_LINKER_FLAGS " -fuse-ld=gold")
  string(APPEND CMAKE_SHARED_LINKER_FLAGS " -fuse-ld=gold")
  string(APPEND CMAKE_MODULE_LINKER_FLAGS " -fuse-ld=gold")
  message(STATUS "Using GNU gold linker.")
endif ()

#-----------------------------------------------------------------------------#
# Use interprocedural optimization if requested

if(ENABLE_IPO)
  set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
endif()

#-----------------------------------------------------------------------------#

# Only enable unit testing if assertions are enabled. Otherwise, unit tests
# that expect AssertionException to be thrown will fail.
if(NOT ENABLE_ASSERTIONS)
  message(STATUS "Disabling unit tests since assertions are disabled.")
  set(ENABLE_UNIT_TESTING OFF)
endif()

#-----------------------------------------------------------------------------#
# Shared/static libraries

# Embed the installation prefix as an RPATH in the executable such that the
# linker can find our libraries (such as libcvc5parser) when executing the
# cvc5 binary. This is for example useful when installing cvc5 with a custom
# prefix on macOS (e.g. when using homebrew in a non-standard directory). If
# we do not set this option, then the linker will not be able to find the
# required libraries when trying to run cvc5.
#
# Also embed the installation prefix of the installed contrib libraries as an
# RPATH. This allows to install a dynamically linked binary that depends on
# dynamically linked libraries. This is dangerous, as the installed binary
# breaks if the contrib library is removed or changes in other ways, we thus
# print a big warning and only allow if installing to a custom installation
# prefix.
#
# More information on RPATH in CMake:
# https://gitlab.kitware.com/cmake/community/wikis/doc/cmake/RPATH-handling
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR};${PROJECT_SOURCE_DIR}/deps/install/lib")

# Set visibility to default if unit tests are enabled. If unit tests are
# enabled, we also check if we can execute white box unit tests (some versions
# of Clang have issues with the required flag).
set(ENABLE_WHITEBOX_UNIT_TESTING OFF)
if(ENABLE_UNIT_TESTING)
  set(CMAKE_CXX_VISIBILITY_PRESET default)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN 0)

  # Check if Clang version has the bug that was fixed in
  # https://reviews.llvm.org/D93104
  set(ENABLE_WHITEBOX_UNIT_TESTING ON)
  check_cxx_compiler_flag("-faccess-control" HAVE_CXX_FLAGfaccess_control)
  if(NOT HAVE_CXX_FLAGfaccess_control)
    set(ENABLE_WHITEBOX_UNIT_TESTING OFF)
    message(STATUS "Disabling white box unit tests")
  endif()
endif()

#-----------------------------------------------------------------------------#
# Enable the ctest testing framework

# This needs to be enabled here rather than in subdirectory test in order to

=== src/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Andrew Reynolds, Gereon Kremer
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# Collect libcvc5 source files
libcvc5_add_sources(
  api/cpp/cvc5.cpp
  api/cpp/cvc5_checks.h
  api/cpp/cvc5_types.cpp
  decision/assertion_list.cpp
  decision/assertion_list.h
  decision/decision_engine.cpp
  decision/decision_engine.h
  decision/justification_strategy.cpp
  decision/justification_strategy.h
  decision/justify_cache.cpp
  decision/justify_cache.h
  decision/justify_info.cpp
  decision/justify_info.h
  decision/justify_stack.cpp
  decision/justify_stack.h
  decision/justify_stats.cpp
  decision/justify_stats.h
  lib/clock_gettime.c
  lib/clock_gettime.h
  lib/ffs.c
  lib/ffs.h
  lib/replacements.h
  lib/strtok_r.c
  lib/strtok_r.h
  omt/bitvector_optimizer.cpp
  omt/bitvector_optimizer.h
  omt/integer_optimizer.cpp
  omt/integer_optimizer.h
  omt/omt_optimizer.cpp
  omt/omt_optimizer.h
  options/language.cpp
  options/language.h
  options/managed_streams.cpp
  options/managed_streams.h
  options/option_exception.cpp
  options/option_exception.h
  options/options_handler.cpp
  options/options_handler.h
  options/options_listener.h
  options/options_public.h
  preprocessing/assertion_pipeline.cpp
  preprocessing/assertion_pipeline.h
  preprocessing/learned_literal_manager.cpp
  preprocessing/learned_literal_manager.h
  preprocessing/passes/ackermann.cpp
  preprocessing/passes/ackermann.h
  preprocessing/passes/apply_substs.cpp
  preprocessing/passes/apply_substs.h
  preprocessing/passes/bool_to_bv.cpp
  preprocessing/passes/bool_to_bv.h
  preprocessing/passes/bv_eager_atoms.cpp
  preprocessing/passes/bv_eager_atoms.h
  preprocessing/passes/bv_gauss.cpp
  preprocessing/passes/bv_gauss.h
  preprocessing/passes/bv_intro_pow2.cpp
  preprocessing/passes/bv_intro_pow2.h
  preprocessing/passes/bv_to_bool.cpp
  preprocessing/passes/bv_to_bool.h
  preprocessing/passes/bv_to_int.cpp
  preprocessing/passes/bv_to_int.h
  preprocessing/passes/extended_rewriter_pass.cpp
  preprocessing/passes/extended_rewriter_pass.h
  preprocessing/passes/foreign_theory_rewrite.cpp
  preprocessing/passes/foreign_theory_rewrite.h
  preprocessing/passes/fun_def_fmf.cpp
  preprocessing/passes/fun_def_fmf.h
  preprocessing/passes/global_negate.cpp
  preprocessing/passes/global_negate.h
  preprocessing/passes/ho_elim.cpp
  preprocessing/passes/ho_elim.h
  preprocessing/passes/int_to_bv.cpp
  preprocessing/passes/int_to_bv.h
  preprocessing/passes/ite_removal.cpp
  preprocessing/passes/ite_removal.h
  preprocessing/passes/ite_simp.cpp
  preprocessing/passes/ite_simp.h
  preprocessing/passes/learned_rewrite.cpp
  preprocessing/passes/learned_rewrite.h
  preprocessing/passes/miplib_trick.cpp
  preprocessing/passes/miplib_trick.h
  preprocessing/passes/nl_ext_purify.cpp
  preprocessing/passes/nl_ext_purify.h
  preprocessing/passes/non_clausal_simp.cpp
  preprocessing/passes/non_clausal_simp.h
  preprocessing/passes/pseudo_boolean_processor.cpp
  preprocessing/passes/pseudo_boolean_processor.h
  preprocessing/passes/quantifiers_preprocess.cpp
  preprocessing/passes/quantifiers_preprocess.h
  preprocessing/passes/real_to_int.cpp
  preprocessing/passes/real_to_int.h
  preprocessing/passes/rewrite.cpp
  preprocessing/passes/rewrite.h
  preprocessing/passes/sep_skolem_emp.cpp
  preprocessing/passes/sep_skolem_emp.h
  preprocessing/passes/sort_infer.cpp
  preprocessing/passes/sort_infer.h
  preprocessing/passes/static_learning.cpp
  preprocessing/passes/static_learning.h
  preprocessing/passes/strings_eager_pp.cpp
  preprocessing/passes/strings_eager_pp.h
  preprocessing/passes/sygus_inference.cpp
  preprocessing/passes/sygus_inference.h
  preprocessing/passes/synth_rew_rules.cpp
  preprocessing/passes/synth_rew_rules.h
  preprocessing/passes/theory_preprocess.cpp
  preprocessing/passes/theory_preprocess.h
  preprocessing/passes/theory_rewrite_eq.cpp
  preprocessing/passes/theory_rewrite_eq.h
  preprocessing/passes/unconstrained_simplifier.cpp
  preprocessing/passes/unconstrained_simplifier.h
  preprocessing/preprocessing_pass.cpp
  preprocessing/preprocessing_pass.h
  preprocessing/preprocessing_pass_context.cpp
  preprocessing/preprocessing_pass_context.h
  preprocessing/preprocessing_pass_registry.cpp
  preprocessing/preprocessing_pass_registry.h
  preprocessing/util/boolean_simplification.cpp
  preprocessing/util/boolean_simplification.h
  preprocessing/util/ite_utilities.cpp
  preprocessing/util/ite_utilities.h
  printer/ast/ast_printer.cpp
  printer/ast/ast_printer.h
  printer/let_binding.cpp
  printer/let_binding.h
  printer/printer.cpp
  printer/printer.h
  printer/smt2/smt2_printer.cpp
  printer/smt2/smt2_printer.h
  printer/tptp/tptp_printer.cpp
  printer/tptp/tptp_printer.h
  proof/annotation_proof_generator.cpp
  proof/annotation_proof_generator.h
  proof/assumption_proof_generator.cpp
  proof/assumption_proof_generator.h
  proof/buffered_proof_generator.cpp
  proof/buffered_proof_generator.h
  proof/conv_proof_generator.cpp
  proof/conv_proof_generator.h
  proof/conv_seq_proof_generator.cpp
  proof/conv_seq_proof_generator.h
  proof/clause_id.h
  proof/dot/dot_printer.cpp
  proof/dot/dot_printer.h
  proof/eager_proof_generator.cpp
  proof/eager_proof_generator.h
  proof/lazy_proof.cpp
  proof/lazy_proof.h
  proof/lazy_proof_chain.cpp
  proof/lazy_proof_chain.h
  proof/lazy_tree_proof_generator.cpp
  proof/lazy_tree_proof_generator.h
  proof/lfsc/lfsc_list_sc_node_converter.cpp
  proof/lfsc/lfsc_list_sc_node_converter.h
  proof/lfsc/lfsc_node_converter.cpp
  proof/lfsc/lfsc_node_converter.h
  proof/lfsc/lfsc_post_processor.cpp
  proof/lfsc/lfsc_post_processor.h
  proof/lfsc/lfsc_printer.cpp
  proof/lfsc/lfsc_printer.h
  proof/lfsc/lfsc_print_channel.cpp
  proof/lfsc/lfsc_print_channel.h
  proof/lfsc/lfsc_util.cpp
  proof/lfsc/lfsc_util.h
  proof/method_id.cpp
  proof/method_id.h
  proof/print_expr.cpp
  proof/print_expr.h
  proof/proof.cpp
  proof/proof.h
  proof/proof_checker.cpp
  proof/proof_checker.h
  proof/proof_ensure_closed.cpp
  proof/proof_ensure_closed.h
  proof/proof_generator.cpp
  proof/proof_generator.h
  proof/proof_letify.cpp
  proof/proof_letify.h
  proof/proof_node.cpp
  proof/proof_node.h
  proof/proof_node_algorithm.cpp
  proof/proof_node_algorithm.h
  proof/proof_node_to_sexpr.cpp
  proof/proof_node_to_sexpr.h
  proof/proof_node_manager.cpp
  proof/proof_node_manager.h
  proof/proof_node_updater.cpp
  proof/proof_node_updater.h
  proof/proof_rule.cpp
  proof/proof_rule.h
  proof/proof_rule_checker.cpp
  proof/proof_rule_checker.h
  proof/proof_set.h
  proof/proof_step_buffer.cpp
  proof/proof_step_buffer.h
  proof/resolution_proofs_util.cpp
  proof/resolution_proofs_util.h
  proof/trust_node.cpp
  proof/trust_node.h
  proof/theory_proof_step_buffer.cpp
  proof/theory_proof_step_buffer.h
  proof/unsat_core.cpp
  proof/unsat_core.h
  proof/alethe/alethe_let_binding.cpp
  proof/alethe/alethe_let_binding.h
  proof/alethe/alethe_node_converter.cpp
  proof/alethe/alethe_node_converter.h
  proof/alethe/alethe_post_processor.cpp
  proof/alethe/alethe_post_processor.h
  proof/alethe/alethe_printer.h
  proof/alethe/alethe_printer.cpp
  proof/alethe/alethe_proof_rule.cpp
  proof/alethe/alethe_proof_rule.h
  prop/cadical.cpp
  prop/cadical.h
  prop/cnf_stream.cpp
  prop/cnf_stream.h
  prop/cryptominisat.cpp
  prop/cryptominisat.h
  prop/kissat.cpp
  prop/kissat.h
  prop/learned_db.cpp
  prop/learned_db.h
  prop/minisat/core/Dimacs.h
  prop/minisat/core/Solver.cc
  prop/minisat/core/Solver.h
  prop/minisat/core/SolverTypes.h
  prop/minisat/minisat.cpp
  prop/minisat/minisat.h
  prop/minisat/mtl/Alg.h
  prop/minisat/mtl/Alloc.h
  prop/minisat/mtl/Heap.h
  prop/minisat/mtl/IntTypes.h
  prop/minisat/mtl/Map.h
  prop/minisat/mtl/Queue.h
  prop/minisat/mtl/Sort.h
  prop/minisat/mtl/Vec.h
  prop/minisat/mtl/XAlloc.h
  prop/minisat/simp/SimpSolver.cc
  prop/minisat/simp/SimpSolver.h
  prop/minisat/utils/Options.h
  prop/opt_clauses_manager.cpp
  prop/opt_clauses_manager.h
  prop/proof_cnf_stream.cpp
  prop/proof_cnf_stream.h
  prop/proof_post_processor.cpp
  prop/proof_post_processor.h
  prop/prop_engine.cpp
  prop/prop_engine.h
  prop/prop_proof_manager.cpp
  prop/prop_proof_manager.h
  prop/registrar.h
  prop/sat_solver.h
  prop/sat_proof_manager.cpp
  prop/sat_proof_manager.h
  prop/sat_solver_factory.cpp
  prop/sat_solver_factory.h
  prop/sat_solver_types.cpp
  prop/sat_solver_types.h
  prop/skolem_def_manager.cpp
  prop/skolem_def_manager.h
  prop/theory_preregistrar.cpp
  prop/theory_preregistrar.h
  prop/theory_proxy.cpp
  prop/theory_proxy.h
  prop/zero_level_learner.cpp
  prop/zero_level_learner.h
  smt/abduction_solver.cpp
  smt/abduction_solver.h
  smt/abstract_values.cpp
  smt/abstract_values.h
  smt/assertions.cpp
  smt/assertions.h
  smt/check_models.cpp
  smt/check_models.h
  smt/context_manager.cpp
  smt/context_manager.h
  smt/difficulty_post_processor.cpp
  smt/difficulty_post_processor.h
  smt/env.cpp
  smt/env.h
  smt/env_obj.cpp
  smt/env_obj.h
  smt/expand_definitions.cpp
  smt/expand_definitions.h
  smt/listeners.cpp
  smt/listeners.h
  smt/logic_exception.h
  smt/interpolation_solver.cpp
  smt/interpolation_solver.h
  smt/model.cpp
  smt/model.h
  smt/model_core_builder.cpp
  smt/model_core_builder.h
  smt/model_blocker.cpp
  smt/model_blocker.h
  smt/optimization_solver.cpp
  smt/optimization_solver.h
  smt/quant_elim_solver.cpp
  smt/quant_elim_solver.h
  smt/preprocessor.cpp
  smt/preprocessor.h
  smt/preprocess_proof_generator.cpp
  smt/preprocess_proof_generator.h
  smt/print_benchmark.cpp
  smt/print_benchmark.h
  smt/process_assertions.cpp
  smt/process_assertions.h
  smt/proof_manager.cpp
  smt/proof_manager.h
  smt/proof_final_callback.cpp
  smt/proof_final_callback.h
  smt/proof_post_processor.cpp
  smt/proof_post_processor.h
  smt/set_defaults.cpp
  smt/set_defaults.h
  smt/solver_engine.cpp
  smt/solver_engine.h
  smt/solver_engine_state.cpp
  smt/solver_engine_state.h
  smt/solver_engine_stats.cpp
  smt/solver_engine_stats.h
  smt/smt_driver.cpp
  smt/smt_driver.h
  smt/smt_driver_deep_restarts.cpp
  smt/smt_driver_deep_restarts.h
  smt/smt_mode.cpp
  smt/smt_mode.h
  smt/smt_solver.cpp
  smt/smt_solver.h
  smt/sygus_solver.cpp
  smt/sygus_solver.h
  smt/term_formula_removal.cpp
  smt/term_formula_removal.h
  smt/unsat_core_manager.cpp
  smt/unsat_core_manager.h
  smt/witness_form.cpp
  smt/witness_form.h
  theory/arith/arith_evaluator.cpp
  theory/arith/arith_evaluator.h
  theory/arith/arith_ite_utils.cpp
  theory/arith/arith_ite_utils.h
  theory/arith/arith_msum.cpp
  theory/arith/arith_msum.h
  theory/arith/arith_poly_norm.cpp
  theory/arith/arith_poly_norm.h
  theory/arith/arith_preprocess.cpp
  theory/arith/arith_preprocess.h
  theory/arith/arith_rewriter.cpp
  theory/arith/arith_rewriter.h
  theory/arith/arith_state.cpp
  theory/arith/arith_state.h
  theory/arith/arith_subs.cpp
  theory/arith/arith_subs.h
  theory/arith/arith_utilities.cpp
  theory/arith/arith_utilities.h
  theory/arith/bound_inference.cpp
  theory/arith/bound_inference.h
  theory/arith/branch_and_bound.cpp
  theory/arith/branch_and_bound.h
  theory/arith/delta_rational.cpp
  theory/arith/delta_rational.h
  theory/arith/equality_solver.cpp
  theory/arith/equality_solver.h
  theory/arith/inference_manager.cpp
  theory/arith/inference_manager.h
  theory/arith/linear/approx_simplex.cpp
  theory/arith/linear/approx_simplex.h
  theory/arith/linear/arith_static_learner.cpp

=== src/base/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Gereon Kremer, Andrew V. Jones
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# Generate cvc5config.h header
configure_file(cvc5config.h.in cvc5config.h)

#-----------------------------------------------------------------------------#

set(LIBBASE_SOURCES
  check.cpp
  check.h
  configuration.cpp
  configuration.h
  configuration_private.h
  exception.cpp
  exception.h
  listener.cpp
  listener.h
  modal_exception.h
  output.cpp
  output.h
  ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.cpp
)
set_source_files_properties(
  ${CMAKE_CURRENT_BINARY_DIR}/versioninfo.cpp
  PROPERTIES GENERATED TRUE
)

#-----------------------------------------------------------------------------#
# Generate code for debug/trace tags

set(collect_tags_script ${CMAKE_CURRENT_LIST_DIR}/collect_tags.py)

file(GLOB_RECURSE source_files
     ${PROJECT_SOURCE_DIR}/src/*.cpp
     ${PROJECT_SOURCE_DIR}/src/*.cc
     ${PROJECT_SOURCE_DIR}/src/*.h
     ${PROJECT_SOURCE_DIR}/src/*.g)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
  COMMAND ${Python_EXECUTABLE} ${collect_tags_script} ${CMAKE_CURRENT_BINARY_DIR}/ ${PROJECT_SOURCE_DIR}/src
  DEPENDS ${collect_tags_script} ${source_files}
)

add_custom_target(gen-tags
  DEPENDS
    ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
)

set_source_files_properties(
  ${CMAKE_CURRENT_BINARY_DIR}/Trace_tags.h
  PROPERTIES GENERATED TRUE
)

add_library(cvc5base OBJECT ${LIBBASE_SOURCES})
set_target_properties(cvc5base PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(cvc5base PRIVATE -D__BUILDING_CVC5LIB -Dcvc5_obj_EXPORTS)
add_dependencies(cvc5base gen-versioninfo gen-tags)

=== src/expr/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Andrew Reynolds, Aina Niemetz
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

libcvc5_add_sources(
  algorithm/flatten.h
  annotation_elim_node_converter.cpp
  annotation_elim_node_converter.h
  array_store_all.cpp
  array_store_all.h
  ascription_type.cpp
  ascription_type.h
  attribute.h
  attribute.cpp
  attribute_internals.h
  attribute_unique_id.h
  bound_var_manager.cpp
  bound_var_manager.h
  cardinality_constraint.cpp
  cardinality_constraint.h
  codatatype_bound_variable.cpp
  codatatype_bound_variable.h
  elim_shadow_converter.cpp
  elim_shadow_converter.h
  emptyset.cpp
  emptyset.h
  emptybag.cpp
  emptybag.h
  function_array_const.cpp
  function_array_const.h
  kind_map.h
  match_trie.cpp
  match_trie.h
  nary_match_trie.cpp
  nary_match_trie.h
  nary_term_util.cpp
  nary_term_util.h
  node.cpp
  node.h
  node_algorithm.cpp
  node_algorithm.h
  node_builder.cpp
  node_builder.h
  node_converter.cpp
  node_converter.h
  node_manager_attributes.h
  node_self_iterator.h
  node_trie.cpp
  node_trie.h
  node_trie_algorithm.cpp
  node_trie_algorithm.h
  node_traversal.cpp
  node_traversal.h
  node_value.cpp
  node_value.h
  oracle.h
  oracle_caller.cpp
  oracle_caller.h
  sequence.cpp
  sequence.h
  node_visitor.h
  skolem_manager.cpp
  skolem_manager.h
  subtype_elim_node_converter.cpp
  subtype_elim_node_converter.h
  term_canonize.cpp
  term_canonize.h
  term_context.cpp
  term_context.h
  term_context_node.cpp
  term_context_node.h
  term_context_stack.cpp
  term_context_stack.h
  type_checker.h
  type_matcher.cpp
  type_matcher.h
  type_node.cpp
  type_node.h
  dtype.h
  dtype.cpp
  dtype_cons.h
  dtype_cons.cpp
  dtype_selector.h
  dtype_selector.cpp
  sequence.cpp
  sequence.h
  subs.cpp
  subs.h
  sygus_datatype.cpp
  sygus_datatype.h
  variadic_trie.cpp
  variadic_trie.h
)

libcvc5_add_sources(GENERATED
  kind.cpp
  kind.h
  metakind.cpp
  metakind.h
  node_manager.cpp
  node_manager.h
  type_checker.cpp
  type_properties.cpp
  type_properties.h
)

#
# Generate code for kinds.
#

set(mkkind_script ${CMAKE_CURRENT_LIST_DIR}/mkkind)
set(mkmetakind_script ${CMAKE_CURRENT_LIST_DIR}/mkmetakind)
set(mkexpr_script ${CMAKE_CURRENT_LIST_DIR}/mkexpr)

add_custom_command(
  OUTPUT kind.h
  COMMAND
    ${mkkind_script}
    ${CMAKE_CURRENT_LIST_DIR}/kind_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/kind.h
  DEPENDS mkkind kind_template.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT kind.cpp
  COMMAND
    ${mkkind_script}
    ${CMAKE_CURRENT_LIST_DIR}/kind_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/kind.cpp
  DEPENDS mkkind kind_template.cpp kind.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT type_properties.h
  COMMAND
    ${mkkind_script}
    ${CMAKE_CURRENT_LIST_DIR}/type_properties_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/type_properties.h
  DEPENDS mkkind type_properties_template.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT type_properties.cpp
  COMMAND
    ${mkkind_script}
    ${CMAKE_CURRENT_LIST_DIR}/type_properties_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/type_properties.cpp
  DEPENDS mkkind type_properties_template.cpp type_properties.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT metakind.h
  COMMAND
    ${mkmetakind_script}
    ${CMAKE_CURRENT_LIST_DIR}/metakind_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/metakind.h
  DEPENDS mkmetakind metakind_template.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT metakind.cpp
  COMMAND
    ${mkmetakind_script}
    ${CMAKE_CURRENT_LIST_DIR}/metakind_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/metakind.cpp
  DEPENDS mkmetakind metakind_template.cpp metakind.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT node_manager.h
  COMMAND
    ${mkmetakind_script}
    ${CMAKE_CURRENT_LIST_DIR}/node_manager_template.h
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/node_manager.h
  DEPENDS mkmetakind node_manager_template.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT node_manager.cpp
  COMMAND
    ${mkmetakind_script}
    ${CMAKE_CURRENT_LIST_DIR}/node_manager_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/node_manager.cpp
  DEPENDS mkmetakind node_manager_template.cpp node_manager.h ${KINDS_FILES}
)

add_custom_command(
  OUTPUT type_checker.cpp
  COMMAND
    ${mkexpr_script}
    ${CMAKE_CURRENT_LIST_DIR}/type_checker_template.cpp
    ${KINDS_FILES}
    > ${CMAKE_CURRENT_BINARY_DIR}/type_checker.cpp
  DEPENDS mkexpr type_checker_template.cpp ${KINDS_FILES}
)

add_custom_target(gen-expr
  DEPENDS
    kind.cpp
    kind.h
    metakind.cpp
    metakind.h
    node_manager.cpp
    node_manager.h
    type_checker.cpp
    type_properties.cpp
    type_properties.h
)

=== src/parser/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Gereon Kremer, Andrew V. Jones
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

find_package(ANTLR3 3.4 REQUIRED)

# Java runtime is required for ANTLR
find_package(Java COMPONENTS Runtime REQUIRED)

# Search for flex installed via homebrew.
if(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/flex") # macOS Intel
  list(APPEND CMAKE_PREFIX_PATH "/opt/homebrew/opt/flex") # macOS Apple Silicon
endif()
find_package(FLEX REQUIRED)

#-----------------------------------------------------------------------------#
# libcvc5parser source files

set(libcvc5parserapi_src_files
  api/cpp/command.cpp
  api/cpp/command.h
  api/cpp/symbol_manager.cpp
  api/cpp/symbol_manager.h
  api/cpp/input_parser.cpp
  api/cpp/input_parser.h
)

set(libcvc5parser_src_files
  antlr_input.cpp
  antlr_input.h
  antlr_input_imports.cpp
  antlr_line_buffered_input.cpp
  antlr_line_buffered_input.h
  bounded_token_buffer.cpp
  bounded_token_buffer.h
  bounded_token_factory.cpp
  bounded_token_factory.h
  flex_input.cpp
  flex_input.h
  flex_lexer.cpp
  flex_lexer.h
  flex_parser.cpp
  flex_parser.h
  input.cpp
  input.h
  line_buffer.cpp
  line_buffer.h
  parse_op.cpp
  parse_op.h
  parser.cpp
  parser.h
  parser_antlr.cpp
  parser_antlr.h
  parser_builder.cpp
  parser_builder.h
  parser_exception.h
  parser_utils.cpp
  parser_utils.h
  smt2/smt2.cpp
  smt2/smt2.h
  smt2/smt2_antlr.cpp
  smt2/smt2_antlr.h
  smt2/smt2_cmd_parser.cpp
  smt2/smt2_cmd_parser.h
  smt2/smt2_lexer.cpp
  smt2/smt2_lexer.h
  smt2/smt2_cmd_parser.cpp
  smt2/smt2_cmd_parser.h
  smt2/smt2_input.cpp
  smt2/smt2_input.h
  smt2/smt2_parser.cpp
  smt2/smt2_parser.h
  smt2/smt2_term_parser.cpp
  smt2/smt2_term_parser.h
  smt2/sygus_input.cpp
  smt2/sygus_input.h
  symbol_table.cpp
  symbol_table.h
  tokens.cpp
  tokens.h
  tptp/tptp.cpp
  tptp/tptp.h
  tptp/tptp_antlr.cpp
  tptp/tptp_antlr.h
  tptp/tptp_input.cpp
  tptp/tptp_input.h
)

#-----------------------------------------------------------------------------#
# Generate parsers for all supported languages

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/smt2)
flex_target(Lexer
            ${CMAKE_CURRENT_SOURCE_DIR}/smt2/smt2_lexer.flex
            ${CMAKE_CURRENT_BINARY_DIR}/smt2/smt2_lexer.cpp)
set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/smt2/smt2_lexer.cpp PROPERTIES GENERATED TRUE)

# The FlexLexer.h header is installed to /usr/include/, but is not found by the
# cross-compilation environment. As a workaround we'll copy the header to the
# current build directory and set the FLEX_INCLUDE_DIRS variable accordingly.
if(WIN32)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/flex)
  file(COPY /usr/include/FlexLexer.h DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/flex)
  set(FLEX_INCLUDE_DIRS ${CMAKE_CURRENT_BINARY_DIR}/flex)
endif()

# We don't want to enable -Wall for code generated by Flex.
set(gen_src_files ${CMAKE_CURRENT_BINARY_DIR}/smt2/smt2_lexer.cpp)
set(GEN_SRC_FLAGS "")
check_cxx_compiler_flag("-Wall" HAVE_CXX_FLAGWall)
if(HAVE_CXX_FLAGWall)
  set(GEN_SRC_FLAGS "${GEN_SRC_FLAGS} -Wno-all")
endif()
check_cxx_compiler_flag("-Werror" HAVE_CXX_FLAGWerror)
if(HAVE_CXX_FLAGWerror)
  set(GEN_SRC_FLAGS "${GEN_SRC_FLAGS} -Wno-error")
endif()
set_source_files_properties(
  ${gen_src_files} PROPERTIES COMPILE_FLAGS "${GEN_SRC_FLAGS}")
# Add generated source files to the parser source files
list(APPEND libcvc5parser_src_files ${gen_src_files})

foreach(lang Smt2 Tptp)
  string(TOLOWER ${lang} lang_dir)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir})

  set(gen_src_files
    ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Lexer.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Parser.cpp)
  add_custom_command(
    OUTPUT
      ${gen_src_files}
      ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Lexer.h
      ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Parser.h
      ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}.tokens
    COMMAND
      ${ANTLR3_COMMAND}
        ${CMAKE_CURRENT_SOURCE_DIR}/${lang_dir}/${lang}.g
        -fo ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}
    COMMAND
      # We actually generate C++ files with ANTLR
      ${CMAKE_COMMAND} -E rename
        ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Lexer.c
        ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Lexer.cpp
    COMMAND
      # We actually generate C++ files with ANTLR
      ${CMAKE_COMMAND} -E rename
        ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Parser.c
        ${CMAKE_CURRENT_BINARY_DIR}/${lang_dir}/${lang}Parser.cpp
    DEPENDS
      ${lang_dir}/${lang}.g
  )
  set_source_files_properties(${gen_src_files} PROPERTIES GENERATED TRUE)

  # We don't want to enable -Wall for code generated by ANTLR.
  set(GEN_SRC_FLAGS "")
  check_cxx_compiler_flag("-Wall" HAVE_CXX_FLAGWall)
  if(HAVE_CXX_FLAGWall)
    set(GEN_SRC_FLAGS "${GEN_SRC_FLAGS} -Wno-all")
  endif()
  check_cxx_compiler_flag("-Werror" HAVE_CXX_FLAGWerror)
  if(HAVE_CXX_FLAGWerror)
    set(GEN_SRC_FLAGS "${GEN_SRC_FLAGS} -Wno-error")
  endif()
  set_source_files_properties(
    ${gen_src_files} PROPERTIES COMPILE_FLAGS "${GEN_SRC_FLAGS}")

  # Add generated source files to the parser source files
  list(APPEND libcvc5parser_src_files ${gen_src_files})
endforeach()

#-----------------------------------------------------------------------------#
# libcvc5parser configuration

add_library(cvc5parser-objs OBJECT ${libcvc5parser_src_files})
set_target_properties(cvc5parser-objs PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(cvc5parser-objs PUBLIC -D__BUILDING_CVC5PARSERLIB -Dcvc5_obj_EXPORTS)

add_library(cvc5parserapi-objs OBJECT ${libcvc5parserapi_src_files})
set_target_properties(cvc5parserapi-objs PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_definitions(cvc5parserapi-objs PUBLIC -D__BUILDING_CVC5LIB -Dcvc5_obj_EXPORTS)

add_dependencies(cvc5parser-objs ANTLR3)
add_dependencies(cvc5parserapi-objs cvc5parser-objs)
target_include_directories(cvc5parser-objs PRIVATE ${ANTLR3_INCLUDE_DIR})
target_include_directories(cvc5parser-objs SYSTEM PRIVATE ${FLEX_INCLUDE_DIRS})

add_library(cvc5parser
  $<TARGET_OBJECTS:cvc5parser-objs>
  $<TARGET_OBJECTS:cvc5parserapi-objs>
)
if(BUILD_SHARED_LIBS)
  set_target_properties(cvc5parser PROPERTIES SOVERSION ${CVC5_SOVERSION})
endif()

set_target_properties(cvc5parser PROPERTIES OUTPUT_NAME cvc5parser)
target_link_libraries(cvc5parser PRIVATE cvc5)
target_link_libraries(cvc5parser PRIVATE ANTLR3)

install(TARGETS cvc5parser
  EXPORT cvc5-targets
  DESTINATION ${CMAKE_INSTALL_LIBDIR})

# The generated lexer/parser files define some functions as
# __declspec(dllexport) via the ANTLR3_API macro, which leads to lots of
# unresolved symbols when linking against libcvc5parser.
# -Wl,--export-all-symbols makes sure that all symbols are exported when
# building a DLL.
if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set_target_properties(cvc5parser-objs
    PROPERTIES LINK_FLAGS "-Wl,--export-all-symbols")
endif()

=== src/rewriter/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Andres Noetzli
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2021 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

# Check if the pyparsing Python module is installed.
check_python_module("pyparsing")

libcvc5_add_sources(GENERATED
  rewrites.cpp
  rewrites.h
)
libcvc5_add_sources(
  basic_rewrite_rcons.cpp
  basic_rewrite_rcons.h
  rewrite_db.cpp
  rewrite_db.h
  rewrite_db_proof_cons.cpp
  rewrite_db_proof_cons.h
  rewrite_db_term_process.cpp
  rewrite_db_term_process.h
  rewrite_proof_rule.cpp
  rewrite_proof_rule.h
)

set(mkrewrites_script ${CMAKE_CURRENT_LIST_DIR}/mkrewrites.py)

add_custom_command(
    OUTPUT
      rewrites.cpp
      rewrites.h
    COMMAND
      ${Python_EXECUTABLE}
      ${mkrewrites_script}
      rewrite-db
      ${CMAKE_CURRENT_LIST_DIR}
      ${REWRITES_FILES}
    DEPENDS
      ${mkrewrites_script}
      ${REWRITES_FILES}
      ${CMAKE_CURRENT_LIST_DIR}/rewrites_template.cpp
      ${CMAKE_CURRENT_LIST_DIR}/rewrites_template.h
    COMMENT
      "Generating rewrites.{h,cpp}"
)

add_custom_target(gen-rewrites
  DEPENDS
    rewrites.cpp
    rewrites.h
)

=== src/util/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Gereon Kremer, Andrew Reynolds
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

configure_file(rational.h.in rational.h)
configure_file(integer.h.in integer.h)
configure_file(real_algebraic_number.h.in real_algebraic_number.h)

libcvc5_add_sources(
  bin_heap.h
  bitvector.cpp
  bitvector.h
  cocoa_globals.cpp
  cocoa_globals.h
  bool.h
  cardinality.cpp
  cardinality.h
  cardinality_class.cpp
  cardinality_class.h
  cocoa_globals.cpp
  cocoa_globals.h
  dense_map.h
  didyoumean.cpp
  didyoumean.h
  divisible.cpp
  divisible.h
  finite_field_value.cpp
  finite_field_value.h
  floatingpoint.cpp
  floatingpoint.h
  floatingpoint_size.cpp
  floatingpoint_size.h
  floatingpoint_literal_symfpu.cpp
  floatingpoint_literal_symfpu_traits.cpp
  gmp_util.h
  hash.h
  iand.h
  index.cpp
  index.h
  ostream_util.cpp
  ostream_util.h
  poly_util.cpp
  poly_util.h
  random.cpp
  random.h
  resource_manager.cpp
  resource_manager.h
  result.cpp
  result.h
  real_algebraic_number_poly_imp.cpp
  real_algebraic_number_poly_imp.h
  regexp.cpp
  regexp.h
  roundingmode.cpp
  roundingmode.h
  safe_print.cpp
  safe_print.h
  sampler.cpp
  sampler.h
  sexpr.cpp
  sexpr.h
  smt2_quote_string.cpp
  smt2_quote_string.h
  statistics_public.cpp
  statistics_public.h
  statistics_registry.cpp
  statistics_registry.h
  statistics_stats.cpp
  statistics_stats.h
  statistics_value.cpp
  statistics_value.h
  string.cpp
  string.h
  synth_result.cpp
  synth_result.h
  uninterpreted_sort_value.cpp
  uninterpreted_sort_value.h
  utility.cpp
  utility.h
)

if(CVC5_USE_CLN_IMP)
  libcvc5_add_sources(rational_cln_imp.cpp integer_cln_imp.cpp)
endif()

if(CVC5_USE_GMP_IMP)
  libcvc5_add_sources(rational_gmp_imp.cpp integer_gmp_imp.cpp)
endif()

=== test/binary/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Yoni Zohar, Andrew V. Jones, Aina Niemetz
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##
include_directories(.)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/include)
include_directories(${CMAKE_BINARY_DIR}/src)

# if we've built using libedit, (--editline) then we want the interactive shell tests
if (USE_EDITLINE)

  # Check for pexpect -- zero return code is success
  execute_process(
    COMMAND ${Python_EXECUTABLE} -c "import pexpect"
    RESULT_VARIABLE PEXPECT_RC
    ERROR_QUIET
  )

  # Add the test if we have pexpect
  if(PEXPECT_RC EQUAL 0)
    add_custom_target(binarytests
      COMMAND ctest --output-on-failure -L "binary" -j${CTEST_NTHREADS} $$ARGS)
    add_test(
      NAME interactive_shell
      COMMAND
      "${Python_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/test/binary/interactive_shell.py"
      WORKING_DIRECTORY "${CMAKE_BINARY_DIR}"
    )
    set_tests_properties(interactive_shell PROPERTIES LABELS "binary")
  endif()
endif()

=== docs/api/cpp/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Aina Niemetz
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2021 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
#
find_package(Doxygen REQUIRED)

# basic parameters
set(DOXYGEN_INPUT_DIR ${PROJECT_SOURCE_DIR}/include/cvc5)
set(DOXYGEN_OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/doxygen)
set(DOXYGEN_INPUT "\
${DOXYGEN_INPUT_DIR}/cvc5.h \
${DOXYGEN_INPUT_DIR}/cvc5_kind.h \
${DOXYGEN_INPUT_DIR}/cvc5_types.h \
${PROJECT_SOURCE_DIR}/src/proof/proof_rule.h \
")
set(DOXYGEN_INDEX_FILE ${DOXYGEN_OUTPUT_DIR}/xml/index.xml)

# create doxygen config file
set(DOXYFILE_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
set(DOXYFILE_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
configure_file(${DOXYFILE_IN} ${DOXYFILE_OUT} @ONLY)

# make sure the outpur directory exists
file(MAKE_DIRECTORY ${DOXYGEN_OUTPUT_DIR})

# add the doxygen target
add_custom_command(
  OUTPUT ${DOXYGEN_INDEX_FILE}
  COMMAND Doxygen::doxygen ${DOXYFILE_OUT}
  MAIN_DEPENDENCY ${DOXYFILE_OUT}
  DEPENDS
    ${DOXYGEN_INPUT_DIR}/cvc5.h
    ${DOXYGEN_INPUT_DIR}/cvc5_kind.h
    ${DOXYGEN_INPUT_DIR}/cvc5_types.h
    ${PROJECT_SOURCE_DIR}/src/proof/proof_rule.h
  COMMENT "Generating doxygen API docs"
)
add_custom_target(docs-cpp DEPENDS ${DOXYGEN_INDEX_FILE})

# tell parent scope where to find the output xml
set(CPP_DOXYGEN_XML_DIR
    "${DOXYGEN_OUTPUT_DIR}/xml"
    PARENT_SCOPE
)

=== examples/api/cpp/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mathias Preiner, Abdalrhman Mohamed, Mudathir Mohamed
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

set(CVC5_EXAMPLES_API
  bags
  bitvectors
  bitvectors_and_arrays
  combination
  datatypes
  extract
  floating_point_arith
  helloworld
  linear_arith
  quickstart
  relations
  sequences
  sets
  strings
  transcendentals
)

foreach(example ${CVC5_EXAMPLES_API})
  cvc5_add_example(${example} "" "api/cpp")
endforeach()

if(USE_COCOA)
  cvc5_add_example(finite_field "" "api/cpp")
endif()

set(SYGUS_EXAMPLES_API
  sygus-fun
  sygus-grammar
  sygus-inv
)

foreach(example ${SYGUS_EXAMPLES_API})
  cvc5_add_example(${example} "${example}.cpp utils.h utils.cpp" "api/cpp")
endforeach()

=== examples/api/java/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Mudathir Mohamed, Aina Niemetz, Mathias Preiner
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

set(EXAMPLES_API_JAVA
   Bags
   BitVectors
   BitVectorsAndArrays
   Combination
   Datatypes
   Exceptions
   Extract
   FloatingPointArith
   HelloWorld
   LinearArith
   QuickStart
   Relations
   Sequences
   Sets
   Statistics
   Strings
   SygusFun
   SygusGrammar
   SygusInv
   Transcendentals
   UnsatCores
)

function(add_java_example example)
  add_jar(${example} ${example}.java
          INCLUDE_JARS "${CVC5_JAR}"
          OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin/api/java")

  set(EXAMPLE_TEST_NAME api/java/${example})

  add_test(
    NAME ${EXAMPLE_TEST_NAME}
    COMMAND
      ${Java_JAVA_EXECUTABLE}
        -cp "${CVC5_JAR}:${CMAKE_BINARY_DIR}/bin/api/java/${example}.jar"
        -Djava.library.path=${CVC5_JNI_PATH}
        ${example}
  )
  set_tests_properties(${EXAMPLE_TEST_NAME} PROPERTIES SKIP_RETURN_CODE 77)
endfunction()

foreach(example ${EXAMPLES_API_JAVA})
  add_java_example(${example})
endforeach()

if(USE_COCOA)
  add_java_example(FiniteField)
endif()

=== examples/api/python/CMakeLists.txt ===
###############################################################################
# Top contributors (to current version):
#   Andres Noetzli, Yoni Zohar, Mudathir Mohamed
#
# This file is part of the cvc5 project.
#
# Copyright (c) 2009-2022 by the authors listed in the file AUTHORS
# in the top-level source directory and their institutional affiliations.
# All rights reserved.  See the file COPYING in the top-level source
# directory for licensing information.
# #############################################################################
#
# The build system configuration.
##

set(EXAMPLES_API_PYTHON
  bags
  bitvectors_and_arrays
  bitvectors
  combination
  datatypes
  exceptions
  extract
  floating_point
  helloworld
  id
  linear_arith
  quickstart
  relations
  sequences
  sets
  strings
  sygus-fun
  sygus-grammar
  sygus-inv
  transcendentals
)

find_package(Python ${CVC5_BINDINGS_PYTHON_VERSION} EXACT REQUIRED)

# Find Python bindings in the corresponding python-*/site-packages directory.
# Lookup Python module directory and store path in PYTHON_MODULE_PATH.
execute_process(COMMAND
                  ${Python_EXECUTABLE} -c
                    "from distutils.sysconfig import get_python_lib;\
                     print(get_python_lib(plat_specific=True,\
                             prefix='${CMAKE_PREFIX_PATH}/../..'))"
                OUTPUT_VARIABLE PYTHON_MODULE_PATH
                OUTPUT_STRIP_TRAILING_WHITESPACE)

function(create_python_example example)
  set(example_test example/api/python/${example})
  add_test(
    NAME ${example_test}
    COMMAND
      "${Python_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/api/python/${example}.py"
  )
  set_tests_properties(${example_test} PROPERTIES
    LABELS "example"
    ENVIRONMENT PYTHONPATH=${PYTHON_MODULE_PATH}:${CMAKE_SOURCE_DIR}/api/python)
endfunction()

foreach(example ${EXAMPLES_API_PYTHON})
  create_python_example(${example})
endforeach()

if(USE_COCOA)
  create_python_example("finite_field")
endif()

=== debian/changelog ===
cvc5 (1.0.5-3) unstable; urgency=medium

  * Post-NEW source-only upload

 -- Scott Talbert <swt@techie.net>  Fri, 23 Jun 2023 15:50:35 -0400

cvc5 (1.0.5-2) unstable; urgency=medium

  * Build Python bindings (Closes: #1034268)

 -- Scott Talbert <swt@techie.net>  Thu, 22 Jun 2023 15:58:34 -0400

cvc5 (1.0.5-1) unstable; urgency=medium

  * Update to new upstream release 1.0.5 (Closes: #1037616)
  * Update Standards-Version to 4.6.2 (no changes needed)
  * Rules-Requires-Root: no

 -- Scott Talbert <swt@techie.net>  Tue, 20 Jun 2023 12:11:06 -0400

=== debian/control ===
Source: cvc5
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Scott Talbert <swt@techie.net>
Section: math
Priority: optional
Build-Depends: antlr3,
               chrpath,
               cmake,
               cxxtest,
               cython3,
               debhelper-compat (= 13),
               dh-sequence-python3,
               libantlr3c-dev,
               libboost-thread-dev,
               libcadical-dev,
               libcln-dev,
               libcryptominisat5-dev,
               libfl-dev,
               libgmp-dev,
               libreadline-dev,
               libsymfpu-dev,
               pkg-config,
               python3,
               python3-dev,
               python3-pyparsing,
               python3-pytest,
               python3-setuptools,
               python3-skbuild,
               python3-toml,
Standards-Version: 4.6.2
Homepage: https://cvc5.github.io/
Vcs-Git: https://salsa.debian.org/science-team/cvc5.git
Vcs-Browser: https://salsa.debian.org/science-team/cvc5
Rules-Requires-Root: no

Package: cvc5
Architecture: any
Depends: libcvc5-1 (= ${binary:Version}),
         libcvc5parser1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: automated theorem prover for SMT problems
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains binaries needed to use cvc5 as a stand-alone
 tool.

Package: libcvc5-dev
Architecture: any
Section: libdevel
Depends: libcvc5-1 (= ${binary:Version}),
         libcvc5parser1 (= ${binary:Version}),
         libgmp-dev,
         ${misc:Depends},
         ${shlibs:Depends},
Description: automated theorem prover for SMT problems (development files)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains development files for cvc5. Install it if you
 want to develop applications that use cvc5's API.

Package: libcvc5-1
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: automated theorem prover for SMT problems (runtime)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains cvc5's runtime shared libraries.

Package: libcvc5parser1
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: automated theorem prover for SMT problems (parser runtime)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains runtime shared libraries for cvc5's parser.

Package: python3-cvc5
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Description: automated theorem prover for SMT problems (Python bindings)
 cvc5 is a tool for determining the satisfiability of a first order formula
 modulo a first order theory (or a combination of such theories).  It is the
 fifth in the Cooperating Validity Checker family of tools (CVC, CVC Lite,
 CVC3, CVC4) but does not directly incorporate code from any previous version
 prior to CVC4.
 .
 cvc5 is intended to be an open and extensible SMT engine.  It can be used as a
 stand-alone tool or as a library.  It has been designed to increase the
 performance and reduce the memory overhead of its predecessors.  It is written
 entirely in C++ and is released under an open-source software license.
 .
 This package contains the Python bindings for cvc5's parser.
